; -----------------------------------------------------------------------------------------------------------
; -----------------------------------^^^^^^^^^^^^^----------------------------------------------------
; ----------------------------------<C L I C K I E M A R T>---------------------------------------------------
; ----------------------------------<Sourcecode programmed by Frank Wiebeler>------------------------------
; -----------------------------------vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv-------------------------------
; -----------------------------------------------------------------------------------------------------------

Enumeration 
      #w_menu
      #w_game
EndEnumeration

Enumeration 
      #g_game
      
      #g_banner
      #g_go
      #g_quit
      #g_colors
      #g_colors_text
      #g_width
      #g_width_text
      #g_height
      #g_height_text
      #g_schwierigkeit
      #g_heighscore
      #g_about
EndEnumeration
Enumeration 
      #ball_none
      #ball_red
      #ball_green
      #ball_blue
      #ball_yellow
      #ball_pink
      #ball_white
      #ball_grey
      #ball_hellblau
      #ball_all
      #game_img
EndEnumeration

Structure Score
        Punkte.l
        Name.s
EndStructure

Global NewList Scores.Score()
Global Dim Felder.b(0,0)
Global Field_width.l
Global Field_Height.l
Global Punkte.l
Procedure CreateBall(id,color)
            CreateImage(id,40,40)
            StartDrawing(ImageOutput(id))
                  Circle(20,20,20,color)
            StopDrawing()
EndProcedure

Procedure BuildField(width,height,maxcolor)
        Global Dim Felder.b(height-1,width-1)
        If OpenWindow(#w_game,0,0,width*40,height*40,"New Game",#PB_Window_SystemMenu)
                CreateGadgetList(WindowID(#w_game))
                        CreateImage(#game_img,width*40,height*40)
                        ImageGadget(#g_game,0,0,width*40,height*40,ImageID(#game_img))
                        DisableGadget(#g_game,1)
        For hoch=0 To height-1
              For lang=0 To width-1
                      Felder(hoch,lang)=1+Random(maxcolor-2)
              Next
        Next 
        Field_Height=height-1
        Field_width=width-1
        ProcedureReturn 1
        EndIf
EndProcedure

Procedure ShowField()
        StartDrawing(ImageOutput(#game_img))
        posy=Field_Height*40
        For hoch=0 To Field_height
              posx=0
              For lang=0 To Field_width
                      DrawImage(ImageID(Felder(hoch,lang)),posx,posy)
                      posx=posx+40
              Next
              posy=posy-40
        Next 
        StopDrawing()
        SetGadgetState(#g_game,ImageID(#game_img))
EndProcedure

Procedure Baellefallen()
        For a=0 To Field_width
              tostep=0
              nextstep=0
              For b=0 To Field_Height
                      If Felder(b,a)=0
                            tostep=tostep+1
                      EndIf
                      If tostep>0
                          Felder(b-nextstep,a)=Felder(b,a)
                          Felder(b,a)=0
                      EndIf
                      nextstep=tostep
              Next
        Next
EndProcedure

Procedure KillBall(y,x)
Protected  Farbe
        Farbe=Felder(y,x)
        Felder(y,x)=0
        menge=1
        If y>0
              If Farbe=Felder(y-1,x)
                      menge=menge+KillBall(y-1,x)
              EndIf
        EndIf
        If x>0
              If Farbe=Felder(y,x-1)
                      menge=menge+KillBall(y,x-1)
              EndIf
        EndIf
        If x<Field_width
              If Farbe=Felder(y,x+1)
                      menge=menge+KillBall(y,x+1)
              EndIf
        EndIf        
        If y<Field_Height
              If Farbe=Felder(y+1,x)
                      menge=menge+KillBall(y+1,x)
              EndIf
        EndIf        
        ProcedureReturn menge
EndProcedure

Procedure RueckNach()
      rueber=0
      For lang=0 To Field_width
            iswat=0
            For hoch=0 To Field_Height
                  If rueber=0
                        If Felder(hoch,lang)<>0
                              iswat=1
                              Break 
                        EndIf
                  Else 
                        If Felder(hoch,lang)<>0
                              iswat=1
                              Felder(hoch,lang-rueber)=Felder(hoch,lang)
                              Felder(hoch,lang)=0
                        ;Else 
                        ;      Break
                        EndIf
                  EndIf 
            Next
            If iswat=0
                  Rueber=Rueber+1
            EndIf
      Next
      ProcedureReturn Rueber
EndProcedure

Procedure NochDoppelte()
        For hoch=0 To Field_Height-1
            For lang=0 To Field_width-1
                If Felder(hoch,lang)<>0
                    If Felder(hoch,lang)=Felder(hoch,lang+1) Or Felder(hoch,lang)=Felder(hoch+1,lang)
                          ProcedureReturn 1
                    EndIf
                EndIf
            Next
        Next 
        lang=Field_width
        For hoch=0  To Field_Height-1
                If Felder(hoch,lang)<>0
                    If  Felder(hoch,lang)=Felder(hoch+1,lang)
                          ProcedureReturn 1
                    EndIf
                EndIf
        Next
        hoch=Field_Height
        For lang=0 To Field_width-1
                If Felder(hoch,lang)<>0
                    If Felder(hoch,lang)=Felder(hoch,lang+1)
                          ProcedureReturn 1
                    EndIf
                EndIf
        Next
EndProcedure

Procedure KillKlick()
          posx=Int(WindowMouseX(1)/40)
          posy=Int((WindowHeight(1)-WindowMouseY(1))/40)
          Farbe=Felder(posy,posx)
          If Felder(posy,posx)=0
                ProcedureReturn 0
          EndIf
          killmenge=KillBall(posy,posx)
          If killmenge<=1
                Felder(posy,posx)=Farbe
                killmenge=0
          EndIf
          ShowField()
          Delay(200)
          BaelleFallen()
          ShowField()
          Delay(200)
          RueckNach()
          ShowField()
          ProcedureReturn killmenge*Pow(2,Int(killmenge/5))
EndProcedure

Procedure GameLoop(breite,hoehe,farben)
Protected event.l,quit.l,Punkte
          If BuildField(breite,hoehe,farben)
                  DisableWindow(#w_menu,1)
                 ShowField()
                 Repeat

                        event=WaitWindowEvent(20)
                        If event=#WM_LBUTTONDBLCLK 
                            Punkte=Punkte+KillKlick() 
                            SetWindowTitle(1,"Punkte: "+Str(punkte))
                            If NochDoppelte()=0
                                    quit=1
                            EndIf
                        ElseIf event=#WM_CLOSE
                                quit=-1
                        EndIf
                Until quit<>0
                DisableWindow(#w_menu,0)
                CloseWindow(#w_game)
                If quit=-1
                       ProcedureReturn 0
                Else 
                      menge=0
                      For hoch=0 To Field_Height
                            For lang=0 To Field_width
                                  If Felder(hoch,lang)<>0
                                          menge=menge+1
                                  EndIf
                            Next
                      Next
                      Punkte=Punkte*Pow((Field_Height+1)*(Field_width+1)-menge,2)/Pow((Field_Height+1)*(Field_width+1),2)
                      ProcedureReturn Punkte
                EndIf
         EndIf
EndProcedure

Procedure Einsteller(txt1id,trackid,txt2id,text.s,min,max,y,state)
                  TextGadget(txt1id,10,y,60,20,text)
                  TrackBarGadget(trackid,70,y,200,20,min,max)
                  SetGadgetState(trackid,state)
                  TextGadget(txt2id,270,y,100,20,"")
                  SetGadgetText(txt2id,Str(state))
EndProcedure

Procedure BerechneSchwierigkeit(breite,hoehe,farben)
 Protected difficult
      difficult=(farben*250)/(breite*hoehe)
      ProcedureReturn difficult
EndProcedure

Procedure LoadScore()
      If ReadFile(1,"Highscore.dat")
          While Loc(1)<Lof(1)
                  AddElement(Scores())
                  Scores()\Punkte=ReadLong(1)
                  Scores()\name=ReadString(1)
          Wend  
          CloseFile(1)
        ForEach Scores()
              AddGadgetItem(#g_heighscore,-1,Str(ListIndex(Scores())+1)+Chr(10)+Str(Scores()\punkte)+Chr(10)+Scores()\name)
        Next 
     EndIf
EndProcedure

Procedure SaveScore()
     If CreateFile(1,"HighScore.dat")
          ForEach Scores()
                WriteLong(1,Scores()\Punkte)
                WriteStringN(1,Scores()\Name)
          Next
     EndIf
EndProcedure

Procedure AddScore(punkte.l,name.s)
        AddElement(Scores())
                Scores()\punkte=punkte
                Scores()\name=name
        SortStructuredList(Scores(),#PB_Sort_Descending,0,#PB_Sort_Long)
        ClearGadgetItemList(#g_heighscore)
        ForEach Scores()
              AddGadgetItem(#g_heighscore,-1,Str(ListIndex(Scores())+1)+Chr(10)+Str(Scores()\punkte)+Chr(10)+Scores()\name)
        Next 
EndProcedure

Procedure MenuLoop()
Protected  quit,event
      If OpenWindow(#w_menu,200,200,300,400,"Clickie Mart",#PB_Window_SystemMenu|#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
            CreateGadgetList(WindowID(#w_menu))
                  id=LoadImage(#PB_Any,"Clickimartbild.bmp")
                  ImageGadget(#g_banner,0,0,300,50,ImageID(id))
                  ButtonGadget(#g_go,20,350,120,20,"Spiel starten")
                  ButtonGadget(#g_quit,160,350,120,20,"Beenden")
                  Einsteller(#PB_Any,#g_colors,#g_colors_text,"Farben",4,#ball_all-1,60,6)
                  Einsteller(#PB_Any,#g_width,#g_width_text,"Breite",5,30,90,12)
                  Einsteller(#PB_Any,#g_height,#g_height_text,"Hoehe",5,25,110,12)
                  TextGadget(#g_schwierigkeit,20,140,200,20,"Schwierigkeitsgrad: 10")
                  ListIconGadget(#g_heighscore,20,180,260,160,"Platz",40)
                  AddGadgetColumn(#g_heighscore,1,"Punkte",110)
                  AddGadgetColumn(#g_heighscore,2,"Name",110)
                  LoadScore()
                  
                  HyperLinkGadget(#g_about,80,380,200,20,"Copyright by Frank Wiebeler 2008",RGB(0,0,255))
                  Repeat 
                        event=WaitWindowEvent()
                        If event=#PB_Event_Gadget
                              Select EventGadget()
                                    Case #g_go
                                            Punkte=GameLoop(GetGadgetState(#g_width),GetGadgetState(#g_height),GetGadgetState(#g_colors))
                                            Punkte=Punkte*BerechneSchwierigkeit(GetGadgetState(#g_width),GetGadgetState(#g_height),GetGadgetState(#g_colors))
                                            MessageRequester("Ergebnis:","Sie haben "+Str(Punkte)+" Punkte erreicht :)")
                                            If punkte>200
                                                    name.s=InputRequester("HighScore!!!","Geben sie ihren Namen ein","")
                                                    AddScore(punkte,name)
                                            EndIf
                                    Case #g_quit
                                            quit=1
                                    Case #g_colors
                                            SetGadgetText(#g_colors_text,Str(GetGadgetState(#g_colors)-1))
                                            SetGadgetText(#g_schwierigkeit,"Schwierigkeit: "+Str(BerechneSchwierigkeit(GetGadgetState(#g_width),GetGadgetState(#g_height),GetGadgetState(#g_colors))))
                                    Case #g_width
                                            SetGadgetText(#g_width_text,Str(GetGadgetState(#g_width)))
                                            SetGadgetText(#g_schwierigkeit,"Schwierigkeit: "+Str(BerechneSchwierigkeit(GetGadgetState(#g_width),GetGadgetState(#g_height),GetGadgetState(#g_colors))))
                                    Case #g_height                                            
                                            SetGadgetText(#g_height_text,Str(GetGadgetState(#g_height)))
                                            SetGadgetText(#g_schwierigkeit,"Schwierigkeit: "+Str(BerechneSchwierigkeit(GetGadgetState(#g_width),GetGadgetState(#g_height),GetGadgetState(#g_colors))))
                                    Case #g_about
                                            text.s="Clicki Mart wurde programmiert von Frank Wiebeler"+Chr(13)
                                            text=text+"Das Teil entstand in 3 Stunden, weil ich langeweile hatte"+Chr(13)
                                            text=text+"Das Spielprinzip stammt nicht von mir, ich wei nicht, wer der Autor ist"+Chr(13)
                                            text=text+Chr(13)
                                            text=text+"Rechtliches:"+Chr(13)
                                            text=text+"   -Die Nutzung geschieht auf eigene Gefahr, fr Schden kann ich nix"+Chr(13)
                                            text=text+"   -Das Programmpaket darf in unvernderter Form ohne Einschrnkung weitergegeben werden"+Chr(13)
                                            text=text+"   -Der Quelltext darf verndert werden, ein Hinweis auf den Originalautor muss verbleiben"+Chr(13)
                                            text=text+Chr(13)
                                            text=text+"_____________________________________________________________________"+Chr(13)
                                            text=text+"Have fun, bis dann"+Chr(13)
                                            text=text+"                                  Frank Wiebeler"+Chr(13)
                                            MessageRequester("About",text,#PB_MessageRequester_Ok|#MB_ICONINFORMATION)
                             EndSelect
                         ElseIf event=#WM_CLOSE
                              quit=1
                        EndIf
                  Until  quit=1
                  SaveScore()
     EndIf
EndProcedure

            CreateImage(#ball_none,40,40)
            CreateBall(#ball_red,RGB(255,0,0))
            CreateBall(#ball_green,RGB(0,255,0))
            CreateBall(#ball_blue,RGB(0,0,255))
            CreateBall(#ball_yellow,RGB(255,255,0))
            CreateBall(#ball_hellblau,RGB(0,255,255))
            CreateBall(#ball_pink,RGB(255,0,255))
            CreateBall(#ball_grey,RGB(180,180,180))
            CreateBall(#ball_white,RGB(255,255,255))
            
            MenuLoop()            
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 6
; Folding = ----
; EnableAsm
; EnableXP
; UseIcon = BfIcon.ICO
; Executable = Click Mart.exe